// plugin script :
displayname="Character Table";
versionstring="1.00.01";
releasedatestring="Apr 1st, 2007";
author="Oldrich Svec<oldrich.svec@gmail.com>";
updateurl="";
homepageurl="";
shortdescription="Character Table";
longdescription="Character Table";
advconfigstring="Character Table";
readmestring="Character Table";
iconfilename="favicon.ico";

aliasstr="cc";
regexstr="^cc ..{0,1}$";
scriptregex=/^cc (.)(.{0,1})$/;
regexfilterstr="";
keywordstr="";
scorestr="300";
//autoreload=true;


// type
UNKNOWN=0;
FILE=1;
FOLDER=2;
ALIAS=3;
URL=4;
PLUGIN=5;
CLIP=5;

// Postprocessing
IMMEDIATE_DISPLAY=0;
ADDSCORE=1;
MATCH_AGAINST_SEARCH=2;

//string.dec2char();  string.char2dec();
(function(){var unicode={'dec2hex':function(ts){return(ts+0).toString(16).toUpperCase()},'dec2hex2':function(ts){var hexequiv=new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");return hexequiv[(ts>>4)&0xF]+hexequiv[ts&0xF]},'dec2hex4':function(ts){var hexequiv=new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");return hexequiv[(ts>>12)&0xF]+hexequiv[(ts>>8)&0xF]+hexequiv[(ts>>4)&0xF]+hexequiv[ts&0xF]},'convertCP2Char':function(ts){var outputString='';ts=ts.replace(/^\s+/,'');if(ts.length==0)return"";ts=ts.replace(/\s+/g,' ');var listArray=ts.split(' ');for(var i=0;i<listArray.length;i++){var n=parseInt(listArray[i],16);if(n<=0xFFFF)outputString+=String.fromCharCode(n);else if(n<=0x10FFFF){n-=0x10000;outputString+=String.fromCharCode(0xD800|(n>>10))+String.fromCharCode(0xDC00|(n&0x3FF))}else outputString+='!erreur '+unicode.dec2hex(n)+'!'}return(outputString)},'convertCP2DecNCR':function(ts){var outputString="";ts=ts.replace(/^\s+/,'');if(ts.length==0)return"";ts=ts.replace(/\s+/g,' ');var listArray=ts.split(' ');for(var i=0;i<listArray.length;i++){var n=parseInt(listArray[i],16);outputString+=('\\u'+n+'?')}return(outputString)},'convertChar2CP':function(ts){var outputString="",haut=0,n=0;for(var i=0;i<ts.length;i++){var b=ts.charCodeAt(i);if(b<0||b>0xFFFF)outputString+='!erreur '+unicode.dec2hex(b)+'!';if(haut!=0){if(0xDC00<=b&&b<=0xDFFF){outputString+=unicode.dec2hex(0x10000+((haut-0xD800)<<10)+(b-0xDC00))+' ';haut=0;continue}else{outputString+='!erreur '+unicode.dec2hex(haut)+'!';haut=0}}if(0xD800<=b&&b<=0xDBFF)haut=b;else outputString+=unicode.dec2hex(b)+' '}return(outputString.replace(/ $/,''))},'convertDecNCR2CP':function(ts){var outputString='';ts=ts.replace(/\s/g,'');var listArray=ts.split(';');for(var i=0;i<listArray.length-1;i++){if(i>0)outputString+=' ';var n=parseInt(listArray[i].substring(2,listArray[i].length),10);outputString+=unicode.dec2hex(n)}return(outputString)}};if(!String.prototype.char2dec)String.prototype.char2dec=function(){return unicode.convertCP2DecNCR(unicode.convertChar2CP(this))};if(!String.prototype.dec2char)String.prototype.dec2char=function(){return unicode.convertCP2Char(unicode.convertDecNCR2CP(this))}})();

var pre_string = "{\\rtf1\\ansi\\ansicpg1250\\deff0\\deftab709{\\fonttbl{\\f0\\fnil\\fcharset0 Arial Unicode MS{\\*\\falt Code2000};}}{\\colortbl ;\\red255\\green0\\blue0;}{\\*\\generator Msftedit 5.41.15.1507;}\\viewkind4\\uc1\\pard\\lang2057\\f0\\fs28 ";
var post_string = "\\par\n}";
var welcome_string = "\\ul Type a letter\\ul0\\par";
var welcome_array = new Array(":","$","!","?","^","/","+","-","*","=",".","a","A","b","B","c","C","d","D","e","E","f","F","g","G","h","H","i","I","j","J","k","K","l","L","m","M","n","N","o","O","p","P","r","R","s","S","t","T","u","U","w","W","x","X","y","Y","z","Z");
var validity_check = "";

var string = new Array();
string[":"] = new Array("\\u32?\\u94?\\u95?\\u94?","\\u61?\\u94?\\u95?\\u94?\\u61?","\\u172?\\u95?\\u172?");
string["$"] = new Array("\\u162?","\\u163?","\\u164?","\\u165?","\\u8364?","\\u8355?","\\u8356?","\\u8359?","\\u8360?","\\u8352?");
string["!"] = new Array("\\u161?","\\u172?");
string["?"] = new Array("\\u191?");
string["^"] = new Array("\\u185?","\\u178?","\\u179?","\\u8319?");
string["/"] = new Array("\\u247?","\\u188?","\\u189?","\\u190?","\\u8539?","\\u8540?","\\u8541?","\\u8542?");
string["+"] = new Array("\\u177?","\\u10003?","\\u10004?","\\u9745?");
string["-"] = new Array("\\u8722?","\\u177?","\\u10007?","\\u10008?","\\u9746?");
string["*"] = new Array("\\u215?");
string["="] = new Array("\\u8776?","\\u8800?","\\u8801?","\\u8804?","\\u8805?");
string["."] = new Array("\\u8230?","\\u183?","\\u8226?","\\u9675?");
string["a"] = new Array("\\u225?","\\u224?","\\u228?","\\u226?","\\u229?","\\u257?","\\u259?","\\u261?","\\u462?","\\u230?","\\u479?","\\u481?","\\u483?","\\u507?","\\u509?","\\u945?");
string["A"] = new Array("\\u193?","\\u192?","\\u196?","\\u194?","\\u197?","\\u256?","\\u258?","\\u260?","\\u461?","\\u198?","\\u478?","\\u480?","\\u482?","\\u506?","\\u508?","\\u913?");
string["b"] = new Array("\\u223?","\\u946?");
string["B"] = new Array("\\u914?");
string["c"] = new Array("\\u231?","\\u269?","\\u263?","\\u267?","\\u265?","\\u169?","\\u967?");
string["C"] = new Array("\\u199?","\\u268?","\\u262?","\\u266?","\\u264?","\\u169?","\\u935?");
string["d"] = new Array("\\u240?","\\u273?","\\u271?","\\u454?","\\u8706?","\\u948?");
string["D"] = new Array("\\u208?","\\u272?","\\u270?","\\u452?","\\u453?","\\u916?");
string["e"] = new Array("\\u233?","\\u232?","\\u235?","\\u234?","\\u275?","\\u277?","\\u279?","\\u281?","\\u283?","\\u477?","\\u8494?","\\u8364?","\\u949?","\\u951?");
string["E"] = new Array("\\u201?","\\u200?","\\u203?","\\u202?","\\u274?","\\u276?","\\u278?","\\u280?","\\u282?","\\u8364?","\\u917?");
string["f"] = new Array("\\u966?");
string["F"] = new Array("\\u8355?","\\u934?");
string["g"] = new Array("\\u285?","\\u287?","\\u289?","\\u291?","\\u485?","\\u487?","\\u947?");
string["G"] = new Array("\\u284?","\\u286?","\\u288?","\\u290?","\\u484?","\\u486?","\\u915?");
string["h"] = new Array("\\u293?","\\u295?");
string["H"] = new Array("\\u292?","\\u294?","\\u919?");
string["i"] = new Array("\\u237?","\\u236?","\\u239?","\\u238?","\\u297?","\\u299?","\\u301?","\\u303?","\\u305?","\\u464?","\\u307?","\\u8734?","\\u8747?","\\u951?","\\u953?");
string["I"] = new Array("\\u205?","\\u204?","\\u207?","\\u206?","\\u296?","\\u298?","\\u300?","\\u304?","\\u302?","\\u463?","\\u306?","\\u919?","\\u921?");
string["j"] = new Array("\\u309?","\\u307?");
string["J"] = new Array("\\u308?","\\u306?");
string["k"] = new Array("\\u311?","\\u312?","\\u489?","\\u954?","\\u967?");
string["K"] = new Array("\\u310?","\\u488?","\\u922?","\\u935?");
string["l"] = new Array("\\u314?","\\u316?","\\u318?","\\u320?","\\u322?","\\u457?","\\u955?");
string["L"] = new Array("\\u313?","\\u315?","\\u317?","\\u319?","\\u321?","\\u455?","\\u456?","\\u8356?","\\u923?");
string["m"] = new Array("\\u956?");
string["M"] = new Array("\\u924?");
string["n"] = new Array("\\u241?","\\u324?","\\u326?","\\u328?","\\u329?","\\u331?","\\u460?","\\u951?","\\u957?");
string["N"] = new Array("\\u209?","\\u323?","\\u325?","\\u327?","\\u330?","\\u458?","\\u459?","\\u919?","\\u925?");
string["o"] = new Array("\\u248?","\\u243?","\\u242?","\\u246?","\\u244?","\\u245?","\\u333?","\\u335?","\\u337?","\\u466?","\\u491?","\\u493?","\\u339?","\\u176?","\\u959?","\\u969?");
string["O"] = new Array("\\u216?","\\u211?","\\u210?","\\u214?","\\u212?","\\u213?","\\u332?","\\u334?","\\u336?","\\u465?","\\u490?","\\u492?","\\u338?","\\u927?","\\u937?");
string["p"] = new Array("\\u254?","\\u8359?","\\u960?","\\u968?");
string["P"] = new Array("\\u222?","\\u223?","\\u928?","\\u936?");
string["r"] = new Array("\\u341?","\\u343?","\\u345?","\\u529?","\\u531?","\\u174?","\\u8730?","\\u961?");
string["R"] = new Array("\\u340?","\\u342?","\\u344?","\\u528?","\\u530?","\\u174?","\\u929?");
string["s"] = new Array("\\u353?","\\u347?","\\u349?","\\u351?","\\u223?","\\u931?","\\u8730?","\\u8747?","\\u963?","\\u962?");
string["S"] = new Array("\\u352?","\\u346?","\\u348?","\\u350?","\\u931?");
string["t"] = new Array("\\u355?","\\u357?","\\u359?","\\u8482?","\\u952?","\\u964?");
string["T"] = new Array("\\u354?","\\u356?","\\u358?","\\u920?","\\u932?");
string["u"] = new Array("\\u250?","\\u249?","\\u252?","\\u251?","\\u361?","\\u363?","\\u365?","\\u367?","\\u369?","\\u371?","\\u468?","\\u470?","\\u472?","\\u474?","\\u476?","\\u533?","\\u535?","\\u965?");
string["U"] = new Array("\\u218?","\\u217?","\\u220?","\\u219?","\\u360?","\\u362?","\\u364?","\\u366?","\\u368?","\\u370?","\\u467?","\\u469?","\\u471?","\\u473?","\\u475?","\\u532?","\\u534?","\\u933?");
string["w"] = new Array("\\u373?");
string["W"] = new Array("\\u372?");
string["x"] = new Array("\\u958?","\\u967?","\\u215?");
string["X"] = new Array("\\u926?","\\u935?","\\u215?");
string["y"] = new Array("\\u253?","\\u255?","\\u375?");
string["Y"] = new Array("\\u221?","\\u376?","\\u374?");
string["z"] = new Array("\\u378?","\\u380?","\\u382?","\\u950?");
string["Z"] = new Array("\\u377?","\\u379?","\\u381?","\\u918?");
string["<"] = new Array("\\u171?","\\u187?");
string[">"] = new Array("\\u187?","\\u171?");

var letters = new Array("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z");

for(var i=0;i<welcome_array.length;i++){
  welcome_string = welcome_string + welcome_array[i] + ")\\tqr\\tx500\\tab ";
  var row = string[welcome_array[i]];
  for(var j=0;j<row.length;j++){
    welcome_string = welcome_string + string[welcome_array[i]][j] + " ";
  }
  welcome_string = welcome_string + "\\par\n";
}

function onInit(c) {
  currentDirectory=c;
}

function onSearchBegin(querykey, explicit, queryraw, querynokeyword) {
  if(!explicit) {
    if(aliasstr.indexOf(querynokeyword)!=-1) {
      FARR.setState(querykey,1);
      FARR.emitResult(querykey,aliasstr, aliasstr, iconfilename,ALIAS,IMMEDIATE_DISPLAY,300);
      FARR.setState(querykey,0);
    }
    return;
  }
  FARR.setStrValue("statusbar","Character Table");
  FARR.setStrValue("window.richeditmode",pre_string + welcome_string + post_string);
}

function onRegexSearchMatch(querykey,querynokeyword) {
  var match_reg = querynokeyword.match(scriptregex);
  var row = string[match_reg[1]];
  if(row){
    if(!match_reg[2]){
        var output = "";
        for(var j=0; j < row.length; j++){
          output = output + letters[j] + ")\\tqr\\tx500\\tab " + row[j] + "\\par\n";
        }

      FARR.setStrValue("window.richeditmode",pre_string + output + post_string);
      FARR.setStrValue("statusbar","Character Table");
    }else{
      if(validity_check != (match_reg[1]+match_reg[2])){
        var string_code = match_reg[2].charCodeAt(0);
        if (string_code > 90) string_code = string_code - 97;
          else string_code = string_code - 65;
        var output = "";
        var re1=/\\u(\d*?)\?/g;
        if(!row[string_code]){
          FARR.setStrValue("window.richeditmode","emtpy");
          FARR.setStrValue("statusbar","Character Table");
          return;
        }
        while(result1=re1.exec(row[string_code])) {
           for(var j=1;result1[j];j++)
            output = output + String.fromCharCode(result1[j]);
        };
        var obj = new ActiveXObject("htmlfile");
        obj.parentWindow.clipboardData.setData("text", output);
        FARR.setStrValue("window.hide","");
        validity_check = match_reg[1]+match_reg[2];
        return;
      }else{
        FARR.setStrValue("window.richeditmode","Warning. Please type different letter.");
        FARR.setStrValue("statusbar","Character Table");
      }
    }
  }else{
    FARR.setStrValue("window.richeditmode","emtpy");
    FARR.setStrValue("statusbar","Character Table");
  }
}
